/* ********** cleanup.c - prepare for exit ********** */

#include "lvb.h"

void cleanup(void)
/* log end time, prevent memory leaks, unlock directory */
{
	extern FILE *logfp;		/* log file */
	time_t endtim;			/* time at end of run */
	Boolean writerr = FALSE;	/* write error on log file */
	extern Dataptr matrix;		/* data matrix */

	/* log end time, if possible */
	endtim = time(NULL);
	if (logfp != NULL)
	{
		if (endtim != -1)
			fprintf(logfp, "End time: %s", ctime(&endtim));
		else
			fputs("End of execution\n", logfp);
	}

	/* log file won't be used again */
	if ((ferror(logfp) != 0) || (fclose(logfp) != 0))
		writerr = TRUE;

	/* prevent leaks */
	bstfree();
	memfree();

	/* if error found on log file, leave lock file to indicate disaster */
	if (writerr == FALSE)
		remove(LOCKFNAM);	/* unlock directory */
	return;

}	/* end cleanup() */
