/* ********** mops.c - basic memory operation ********** */

#include "lvb.h"

void *alloc(const size_t bytes, const char *const msg)
/* return pointer to bytes bytes of new memory, or on failure crash with
 * message "FATAL ERROR: out of memory: cannot allocate for ", followed by msg;
 * or, if bytes exceeds MAX_ALLOC, crash verbosely without attempting
 * allocation */
{
	void *p;	/* new memory */

	if ((unsigned long) bytes > (unsigned long) MAX_ALLOC)
		crash("can't allocate memory for %s:\n"
		 " requested block too large", msg);
	p = malloc(bytes);
	if (p == NULL)
		crash("out of memory: cannot allocate for %s", msg);
	return p;

}	/* end alloc() */
