/* ********** randpint.c ********** */

/* get random non-negative integer */

#include "lvb.h"

Integer randpint(const Integer upper)       
/* return an integer greater than or equal to 0 and less than or equal to
 * upper;
 * N.B. assumes the random number generator has been initialized by calling
 * rinit()*/
{
	Real frand;     /* random real */
	Real fupper;    /* upper limit */
	Integer rand;   /* return value */

	fupper = (Real) upper;
	frand = (Real) uni();
	frand = frand * fupper;                 /* scale to right range */
	rand = (Integer) (frand + 0.5);         /* round to nearest integer */

	/* guard against arithmetic inaccuracy */
	if (rand < 0)
		rand = 0;
	else if (rand > upper)
		rand = upper;

	return rand;

}	/* end randpint() */
