/* ********** signal.c - portable ANSI signal trapping ********** */

#include "lvb.h"

static void tr_fpe(int sig);
static void tr_hup(int sig);
static void tr_int(int sig);
static void tr_term(int sig);

void settraps(void)
/* set non-returning traps for SIGFPE, SIGHUP, SIGINT and SIGTERM if they are
 * defined */
{
#ifdef SIGFPE
	signal(SIGFPE, tr_fpe);
#endif	/* ifdef SIGFPE */
#ifdef SIGHUP
	signal(SIGHUP, tr_hup);
#endif	/* ifdef SIGHUP */
#ifdef SIGINT
	signal(SIGINT, tr_int);
#endif	/* ifdef SIGINT */
#ifdef SIGTERM
	signal (SIGTERM, tr_term);
#endif	/* ifdef SIGTERM */
	return;

}	/* end settraps() */

static void tr_fpe(int sig)
/* trap arithmetic error */
{
	crash("arithmetic error signal SIGFPE (%d) received", sig);

}	/* end tr_sigfpe() */

static void tr_hup(int sig)
/* trap hangup */
{
	crash("hangup signal SIGHUP (%d) received", sig);

}	/* end tr_hup() */

static void tr_int(int sig)
/* trap interrupt */
{
	crash("interrupt signal SIGINT (%d) received", sig);

}	/* end tr_int() */

static void tr_term(int sig)
/* trap termination request */
{
	crash("termination request signal SIGTERM (%d) received", sig);

}	/* end tr_term() */
